// MsgCom.h : Declaration of the CMsgCom

#ifndef __MSGCOM_H_
#define __MSGCOM_H_

#include "resource.h"       // main symbols
#include "list"


typedef std::list<IListener*> LsnList;
/////////////////////////////////////////////////////////////////////////////
// CMsgCom
class ATL_NO_VTABLE CMsgCom : 
	public CComObjectRootEx<CComSingleThreadModel>, //<CComMultiThreadModel>,
	public CComCoClass<CMsgCom, &CLSID_MsgCom>,
	public IMsgCom
{
public:
	CMsgCom()
	{
	}

	LsnList	regList;

	STDMETHOD(RegisterListener)(IListener* pListener)
	{
		pListener->AddRef();
		regList.push_back(pListener);
		return S_OK;
	}
	STDMETHOD(UnRegisterListener)(IListener* pListener)
	{
		return S_OK;
	}
	STDMETHOD(FireMessage)(IMessage* pMsg) // ICTMessage : From, MsgID, ...
	{
		LsnList::iterator it;
		for (it = regList.begin(); it != regList.end(); ++it)
		{
			(*it)->HandleMessage(pMsg);
		}
		return S_OK;
	}


DECLARE_REGISTRY_RESOURCEID(IDR_MSGCOM)

DECLARE_CLASSFACTORY_SINGLETON(CMsgCom)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMsgCom)
//	COM_INTERFACE_ENTRY_BREAK(IMsgCom)
	COM_INTERFACE_ENTRY(IMsgCom)
END_COM_MAP()

// IMsgCom
public:
};

#endif //__MSGCOM_H_
