// PopupMgr.h : Declaration of the CPopupMgr

#ifndef __POPUPMGR_H_
#define __POPUPMGR_H_

#include "resource.h"       // main symbols
#include "hostex.h"

/////////////////////////////////////////////////////////////////////////////
// CPopupMgr
class ATL_NO_VTABLE CPopupMgr : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPopupMgr, &CLSID_PopupMgr>,
	public IPopupMgr,
	public IListener
{
public:
	CPopupMgr()
	{
		IMsgCom* pMsgMan;
		IClassFactory* pCF;
		_Module.GetClassObject(CLSID_MsgCom, IID_IClassFactory, (void**)&pCF);
		HRESULT hr = pCF->CreateInstance(NULL, IID_IMsgCom, (void**)&pMsgMan);

		IListener* pListener;
		QueryInterface(IID_IListener, (void**)&pListener);
		pMsgMan->RegisterListener(pListener);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_POPUPMGR)
DECLARE_NOT_AGGREGATABLE(CPopupMgr)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CPopupMgr)
	COM_INTERFACE_ENTRY(IPopupMgr)
	COM_INTERFACE_ENTRY(IListener)
END_COM_MAP()

	STDMETHOD(HandleMessage)(IMessage* pMsg)
	{
		IPopup* pu;
		if (S_OK == pMsg->QueryInterface(IID_IPopup, (void**)&pu))
		{
			CLSID cls;
			pu->GetID(&cls);

			// Create popup window
			// CreateControl hosted in pw
			RECT rc = {0,0,0,26};
			pu->GetRect(&rc);

			CAxWindow wnd;
			wnd.Create(NULL, rc, "", WS_POPUP | WS_VISIBLE);

			LPOLESTR oleCls = (LPOLESTR)CoTaskMemAlloc(128);
			StringFromCLSID(cls, &oleCls);
			AtlAxCreateControl2(oleCls, wnd, NULL, NULL);
			CoTaskMemFree(oleCls);
		}

		return S_OK;
	}

// IPopupMgr
public:

};

#endif //__POPUPMGR_H_
