#ifndef _HOSTEX_H
#define _HOSTEX_H

#include "atlhost.h"

class CAxHostWindowEx : public CAxHostWindow
{
public:
	CAxHostWindowEx()
	{
		m_bTrack = false;
	}
	~CAxHostWindowEx()
	{
	}

	DECLARE_NOT_AGGREGATABLE(CAxHostWindowEx);

	BEGIN_MSG_MAP(CAxHostWindowEx)
		if (m_bWindowless)
		{
			MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)
			MESSAGE_HANDLER(WM_MOUSELEAVE, OnMouseLeave)
			MESSAGE_HANDLER(WM_CAPTURECHANGED, OnWindowMessage)

			// Mouse messages handled when a windowless control has captured the cursor
			// or if the cursor is over the control
			DWORD dwHitResult = m_bCapture ? HITRESULT_HIT : HITRESULT_OUTSIDE;
			if (dwHitResult == HITRESULT_OUTSIDE && m_spViewObject != NULL)
			{
				POINT ptMouse = { LOWORD(lParam), HIWORD(lParam) };
				m_spViewObject->QueryHitPoint(DVASPECT_CONTENT, &m_rcPos, ptMouse, 0, &dwHitResult);
			}
			if (dwHitResult == HITRESULT_HIT)
			{
				MESSAGE_HANDLER(WM_MOUSEWHEEL, OnWindowlessMouseMessage)
			}
		}
		CHAIN_MSG_MAP(CAxHostWindow)
	END_MSG_MAP()


	LRESULT OnMouseMove(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		if (!m_bTrack)
		{
			TRACKMOUSEEVENT et;
			et.cbSize = sizeof(et);
			et.dwFlags = TME_QUERY;
			::TrackMouseEvent(&et);

			et.hwndTrack = m_hWnd;
			et.dwFlags |= TME_LEAVE;
			::TrackMouseEvent(&et);

			m_bTrack = true;
		}

		bHandled = false;
		return 0;
	}
	LRESULT OnMouseLeave(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		m_bTrack = false;
		OnWindowMessage(uMsg, wParam, lParam, bHandled);
		return 0;
	}

protected:
	bool	m_bTrack;
};

extern ATLAPI AtlAxCreateControlEx2(LPCOLESTR lpszName, HWND hWnd, IStream* pStream, 
		IUnknown** ppUnkContainer, IUnknown** ppUnkControl, REFIID iidSink, IUnknown* punkSink);
extern ATLAPI AtlAxCreateControl2(LPCOLESTR lpszName, HWND hWnd, IStream* pStream, IUnknown** ppUnkContainer);
extern ATLAPI AtlAxAttachControl2(IUnknown* pControl, HWND hWnd, IUnknown** ppUnkContainer);


#endif //_HOSTEX_H
